window.Gleam.initSearch([{"doc":"pocket_watch","title":"pocket_watch","content":"# pocket_watch\n\n[![Package Version](https://img.shields.io/hexpm/v/pocket_watch)](https://hex.pm/packages/pocket_watch)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/pocket_watch/)\n\n```sh\ngleam add pocket_watch@1\n```\n```gleam\nimport gleam/io\nimport pocket_watch\n\npub fn main() {\n  {\n    use &lt;- pocket_watch.simple(&quot;test 1&quot;)\n\n    a_long()\n    |&gt; long\n    |&gt; very\n    |&gt; slow\n    |&gt; pipeline\n  } // pocket_watch [test 1]: took 42.0s\n\n  {\n    let print_time = fn(label, elapsed) { io.println(label &lt;&gt; &quot; took a whole &quot; &lt;&gt; elapsed &lt;&gt; &quot;!&quot;) }\n    use &lt;- pocket_watch.callback(&quot;test 2&quot;, print_time)\n\n    another_very()\n    slow_block_of_code()\n  } // test 2 took a whole 6.9m!\n\n  let fun = fn() { a_slow_function(&quot;with&quot;, &quot;arguments&quot;) }\n  \n  pocket_watch.simple(&quot;test 3&quot;, fun) // pocket_watch [test 3]: took 800ms\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/pocket_watch&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"pocket_watch","title":"callback","content":"pub fn callback(\n  label label: String,\n  with callback: fn(String, String) -&gt; Nil,\n  time body: fn() -&gt; a,\n) -&gt; a\n Log time taken using a provided callback.\n\n ## Examples:\n \n let print_time = fn(label, elapsed) { io.println(label &lt;&gt; &quot; took &quot; &lt;&gt; elapsed) }\n\n {\n   use &lt;- pocket_watch.callback(&quot;test&quot;, print_time)\n\n   process.sleep(1000)\n } // test took 1.0s\n \nSynonyms:\npocket_watch.callback\npocket_watch callback","url":"pocket_watch.html#callback"},{"doc":"pocket_watch","title":"callback_us","content":"pub fn callback_us(\n  label label: String,\n  with callback: fn(String, Int) -&gt; Nil,\n  time body: fn() -&gt; a,\n) -&gt; a\n Log time taken using a provided callback that takes `Int` microseconds as argument.\n\n ## Examples:\n \n let print_time = fn(label, elapsed) {\n   io.println(label &lt;&gt; &quot; took &quot; &lt;&gt; int.to_string(elapsed / 1_000) &lt;&gt; &quot;ms&quot;)\n }\n\n {\n   use &lt;- pocket_watch.callback(&quot;test&quot;, print_time)\n\n   process.sleep(1000)\n } // test took 1000ms\n \nSynonyms:\npocket_watch.callback_us\npocket_watch callback_us","url":"pocket_watch.html#callback_us"},{"doc":"pocket_watch","title":"simple","content":"pub fn simple(label: String, body: fn() -&gt; a) -&gt; a\n Log time taken using a default callback with `io.println`.\n\n ## Examples:\n \n {\n   use &lt;- pocket_watch.simple(&quot;test&quot;)\n\n   process.sleep(1000)\n } // pocket_watch [test]: took 1.0s\n \nSynonyms:\npocket_watch.simple\npocket_watch simple","url":"pocket_watch.html#simple"},{"doc":"pocket_watch","title":"pocket_watch","content":"","url":"pocket_watch.html"}]);